

#include "IrrCompileConfig.h"



#ifdef _IRR_COMPILE_WITH_WINDOWS_DEVICE_


#define WIN32_LEAN_AND_MEAN
#if !defined(_IRR_XBOX_PLATFORM_)
	#include <windows.h>
	#include <mmsystem.h> // For JOYCAPS
	#include <windowsx.h>
#endif


#include "CKeyboard.h"
#include "CMouse.h"
#include "IrrlichtDevice.h"



namespace irr
{




// some French doc on windows input available at http://tcharles.developpez.com
bool
CKeyboard::isKeyPressed(EKEY_CODE const& key) {

    // Maybe check if it matches
    int vkey = key;
    return GetAsyncKeyState(vkey) != 0;

}




////////////////////////////////////////////////////////////
bool
CMouse::isButtonPressed(E_MOUSE_BUTTON_STATE_MASK const& button)
{
    int vkey = 0;
    switch (button)
    {
        case EMBSM_LEFT:     vkey = VK_LBUTTON;  break;
        case EMBSM_RIGHT:    vkey = VK_RBUTTON;  break;
        case EMBSM_MIDDLE:   vkey = VK_MBUTTON;  break;
#if(_WIN32_WINNT >= 0x0500)
        case EMBSM_EXTRA1:   vkey = VK_XBUTTON1; break;
        case EMBSM_EXTRA2:   vkey = VK_XBUTTON2; break;
#endif
        default:    return false;
    }

    return GetAsyncKeyState(vkey) != 0;
}


/*
////////////////////////////////////////////////////////////
vector2di
CMouse::getMousePosition()
{
    POINT point;
    GetCursorPos(&point);
    return Vector2i(point.x, point.y);
}

//
//////////////////////////////////////////////////////////////
vector2di
CMouse::getMousePosition(const IrrlichtDevice* relativeTo)
{
    WindowHandle handle = relativeTo.GetSystemHandle();
    if (handle)
    {
        POINT point;
        GetCursorPos(&point);
        ScreenToClient(handle, &point);
        return Vector2i(point.x, point.y);
    }
    else
    {
        return Vector2i();
    }
}


////////////////////////////////////////////////////////////
void
CMouse::setMousePosition(const Vector2i& position,const )
{
    //
    SetCursorPos(position.x, position.y);
}


////////////////////////////////////////////////////////////
//void
//CMouse::SetMousePosition(const Vector2i& position, const Window& relativeTo)
//{
//    WindowHandle handle = relativeTo.GetSystemHandle();
//    if (handle)
//    {
//        POINT point = {position.x, position.y};
//        ClientToScreen(handle, &point);
//        SetCursorPos(point.x, point.y);
//    }
//}
//
*/


}  // namespace irr



#endif // _IRR_COMPILE_WITH_WINDOWS_DEVICE_
